/*
	ȈՉ摜Cu F(color.c)
*/

#include <stdio.h>
#include <string.h>
#include "image.h"
#include "depend.h"

/*
	O:
	 pix2r, pix2g, pix2b   - flRGB𓾂
	 rgb2pix               - RGBfl𓾂

	:
	 RGBƉfl̑ݕϊs.

	߂l:
	 vf܂͉fl߂
*/
int pix2r(uint32 pix) { return PIX2R(pix); }
int pix2g(uint32 pix) { return PIX2G(pix); }
int pix2b(uint32 pix) { return PIX2B(pix); }
uint32 rgb2pix(int r, int g, int b)
{
	return RGB2PIX(MINMAX(r, 0, 0xff), MINMAX(g, 0, 0xff), MINMAX(b, 0, 0xff));
}

/*
	O:
	 rgb2y - RGBPx߂
	 pix2y - flPx𓾂

	:
	 flERGBPx߂

	߂l:
	 evf߂
*/
int rgb2y(int r, int g, int b) { return RGB2Y(r, g, b); }
int pix2y(uint32 pix) { return PIX2Y(pix); }

/*
	O:
	 rgb2i, rgb2q           - RGBYIQ()ɕϊ
	 yiq2r, yiq2g, yiq2b    - YIQ()RGBɕϊ
	 pix2i, pix2q           - flYIQ()𓾂
	 rgb2yiq                - YIQ()fl𓾂

	:
	 flERGBYIQ()̑ݕϊs.

	߂l:
	 evf߂
*/
int rgb2i(int r, int g, int b) { return RGB2I(r, g, b); }
int rgb2q(int r, int g, int b) { return RGB2Q(r, g, b); }
int yiq2r(int y, int i, int q) { return YIQ2R(y, i, q); }
int yiq2g(int y, int i, int q) { return YIQ2G(y, i, q); }
int yiq2b(int y, int i, int q) { return YIQ2B(y, i, q); }
int pix2i(uint32 pix) { return PIX2I(pix); }
int pix2q(uint32 pix) { return PIX2Q(pix); }
uint32 yiq2pix(int y, int i, int q)
{
	return rgb2pix(YIQ2R(y, i, q), YIQ2G(y, i, q), YIQ2B(y, i, q));
}

/*
	O:
	 rgb2ui, rgb2uq         - RGBYIQ(Ȃ)ɕϊ
	 uyiq2r, uyiq2g, uyiq2b - YIQ(Ȃ)RGBɕϊ
	 pix2ui, pix2uq         - flYIQ(Ȃ)𓾂
	 uyiq2pix               - YIQ(Ȃ)fl𓾂

	:
	 flERGBYIQ(Ȃ)̑ݕϊs.

	߂l:
	 evf߂
*/
int rgb2ui(int r, int g, int b) { return RGB2UI(r, g, b); }
int rgb2uq(int r, int g, int b) { return RGB2UQ(r, g, b); }
int uyiq2r(int y, int ui, int uq) { return UYIQ2R(y, ui, uq); }
int uyiq2g(int y, int ui, int uq) { return UYIQ2G(y, ui, uq); }
int uyiq2b(int y, int ui, int uq) { return UYIQ2B(y, ui, uq); }
int pix2ui(uint32 pix) { return PIX2UI(pix); }
int pix2uq(uint32 pix) { return PIX2UQ(pix); }
uint32 uyiq2pix(int y, int ui, int uq)
{
	return rgb2pix(UYIQ2R(y, ui, uq), UYIQ2G(y, ui, uq), UYIQ2B(y, ui, uq));
}

/*
	O:
	 rgb2u, rgb2v           - RGBYUVɕϊ()
	 yuv2r, yuv2g, yuv2b    - YUV()RGBɕϊ
	 pix2u, pix2v           - flYUV()𓾂
	 rgb2yuv                - YUV()fl𓾂

	:
	 flERGBYUV̑ݕϊ()s.

	߂l:
	 evf߂
*/
int rgb2u(int r, int g, int b) { return RGB2U(r, g, b); }
int rgb2v(int r, int g, int b) { return RGB2V(r, g, b); }
int yuv2r(int y, int u, int v) { return YUV2R(y, u, v); }
int yuv2g(int y, int u, int v) { return YUV2G(y, u, v); }
int yuv2b(int y, int u, int v) { return YUV2B(y, u, v); }
int pix2u(uint32 pix) { return PIX2U(pix); }
int pix2v(uint32 pix) { return PIX2V(pix); }
uint32 yuv2pix(int y, int u, int v)
{
	return rgb2pix(YUV2R(y, u, v), YUV2G(y, u, v), YUV2B(y, u, v));
}

/*
	O:
	 rgb2uu, rgb2uv         - RGBYUVɕϊ(Ȃ)
	 uyuv2r, uyuv2g, uyuv2b - YUV(Ȃ)RGBɕϊ
	 pix2uu, pix2uv         - flYUV(Ȃ)𓾂
	 rgb2uyuv               - YUV(Ȃ)fl𓾂

	:
	 flERGBYUV(Ȃ)̑ݕϊs.

	߂l:
	 evf߂
*/
int rgb2uu(int r, int g, int b) { return RGB2UU(r, g, b); }
int rgb2uv(int r, int g, int b) { return RGB2UV(r, g, b); }
int uyuv2r(int y, int uu, int uv) { return UYUV2R(y, uu, uv); }
int uyuv2g(int y, int uu, int uv) { return UYUV2G(y, uu, uv); }
int uyuv2b(int y, int uu, int uv) { return UYUV2B(y, uu, uv); }
int pix2uu(uint32 pix) { return PIX2UU(pix); }
int pix2uv(uint32 pix) { return PIX2UV(pix); }
uint32 uyuv2pix(int y, int uu, int uv)
{
	return rgb2pix(UYUV2R(y, uu, uv), UYUV2G(y, uu, uv), UYUV2B(y, uu, uv));
}

/*
	RGBHSV߂()
*/
static inline void rgb2hsv(int *h, int *s, int *v, int r, int g, int b)
{
	int max, min;

	max = MAX3(r, g, b);
	min = MIN3(r, g, b);

	if(max == min)
		*h = 0;
	else if(max == r)
		*h = 60 * (g - b) / (max - min);
	else if(max == g)
		*h = 60 * (b - r) / (max - min) + 120;
	else
		*h = 60 * (r - g) / (max - min) + 240;

	if(max == 0)
		*s = 0;
	else
		*s = 255 * (max - min) / max;

	*v = max;
}

/*
	HSVRGB߂()
*/
static inline void hsv2rgb(int *r, int *g, int *b, int h, int s, int v)
{
	int i, f, p, q, t;

	i = (h / 60) % 6;
	f = h - 60 * i;

	p = v - v * s / 255;
	q = v - v * f * s / 60 / 255;
	t = v - v * s / 255 + v * f * s / 60 / 255;

	switch(i) {
	case 0:
		*r = v; *g = t; *b = p;
		break;
	case 1:
		*r = q; *g = v; *b = p;
		break;
	case 2:
		*r = p; *g = v; *b = t;
		break;
	case 3:
		*r = p; *g = q; *b = v;
		break;
	case 4:
		*r = t; *g = p; *b = v;
		break;
	case 5:
		*r = v; *g = p; *b = q;
		break;
	}
}

/*
	flHSV߂()
*/
static void pix2hsv(int *h, int *s, int *v, uint32 pix)
{
	static uint32 _pix = 0;
	static int _h, _s, _v;

	if(pix != _pix) {
		rgb2hsv(&_h, &_s, &_v, pix2r(pix), pix2g(pix), pix2b(pix));
		_pix = pix;
	}
	*h = _h;
	*s = _s;
	*v = _v;
}

/*
	O:
	 rgb2hsv_h, rgb2hsv_s, rgb2hsv_v - RGBHSVɕϊ
	 hsv2r, hsv2g, hsv2b             - HSVRGBɕϊ
	 pix2hsv_h, pix2hsv_s, pix2hsv_v - flHSV𓾂
	 hsv2pix                         - HSVfl𓾂

	:
	 flERGBHSV̑ݕϊs.

	߂l:
	 evf߂
*/
int pix2hsv_h(uint32 pix)
{
	int h, s, v;

	pix2hsv(&h, &s, &v, pix);
	return h;
}
int pix2hsv_s(uint32 pix)
{
	int h, s, v;

	pix2hsv(&h, &s, &v, pix);
	return s;
}
int pix2hsv_v(uint32 pix)
{
	int h, s, v;

	pix2hsv(&h, &s, &v, pix);
	return v;
}
uint32 hsv2pix(int h, int s, int v)
{
	static uint32 _pix = 0;
	static int _h, _s, _v;
	int r, g, b;

	if(h != _h || s != _s || v != _v) {
		hsv2rgb(&r, &g, &b, h, s, v);
		_h = h;
		_s = s;
		_v = v;
		_pix = rgb2pix(r, g, b);
	}
	return _pix;
}
int rgb2hsv_h(int r, int g, int b)
{
	return pix2hsv_h(rgb2pix(r, g, b));
}
int rgb2hsv_s(int r, int g, int b)
{
	return pix2hsv_s(rgb2pix(r, g, b));
}
int rgb2hsv_v(int r, int g, int b)
{
	return pix2hsv_v(rgb2pix(r, g, b));
}
int hsv2r(int h, int s, int v)
{
	return pix2r(hsv2pix(h, s, v));
}
int hsv2g(int h, int s, int v)
{
	return pix2g(hsv2pix(h, s, v));
}
int hsv2b(int h, int s, int v)
{
	return pix2b(hsv2pix(h, s, v));
}

/*
	O:
	 num2pix - flɕϊ
	 pix2num - fl𐮐ɕϊ

	:
	 Ɖfl̑ݕϊs. , Imageϐ摜ȊÔ̂Ƃ
	Ĉ(Ⴆ΃xOȂ)ƂɎgp.

	߂l:
	 fl܂͐߂.
*/
uint32 num2pix(int n)
{
	return rgb2pix(n & 0xff, (n >> 8) & 0xff, (n >> 16) & 0xff);
}
int pix2num(uint32 pix)
{
	return (PIX2R(pix)) | (PIX2G(pix) << 8) | (PIX2B(pix) << 16);
}

/*
	flF̖O߂
*/
char *pix2name(char *name, uint32 pix)
{
	FILE *fp;
	int y, u, v, y0, u0, v0, r, g, b, d, d_min = INT_MAX;
	char buf[256], tmp[256];

	if((fp = fopen(imgParam.pathRGB, "r")) == NULL) {
		strcpy(name, "");
		return name;
	}

	y0 = PIX2Y(pix);
	u0 = PIX2U(pix);
	v0 = PIX2V(pix);

	while(!feof(fp)) {
		fgets(buf, sizeof(buf), fp);
		if(buf[0] == '!')
			continue;
		sscanf(buf, "%d %d %d %s", &r, &g, &b, tmp);
		y = RGB2Y(r, g, b);
		u = RGB2U(r, g, b);
		v = RGB2V(r, g, b);

		d = (y - y0) * (y - y0) + (u - u0) * (u - u0) + (v - v0) * (v - v0);
		if(d < d_min) {
			d_min = d;
			strcpy(name, tmp);
			if(d == 0)
				break;
		}
	}

	fclose(fp);

	return name;
}

/*
	F̖Ofl߂
*/
uint32 name2pix(const char *name)
{
	FILE *fp;
	int r, g, b;
	char buf[256], tmp[256];

	if((fp = fopen(imgParam.pathRGB, "r")) == NULL)
		return 0;

	while(!feof(fp)) {
		fgets(buf, sizeof(buf), fp);
		if(buf[0] == '!')
			continue;
		sscanf(buf, "%d %d %d %s", &r, &g, &b, tmp);

		if(strcmp(name, tmp) == 0)
			return RGB2PIX(r, g, b);
	}

	fclose(fp);

	return 0;
}

/* eof */
