;
; |Pbg|[J[ for PC-G850/S/V/VS
; Q[
;

; N
RANK_2 = 0
RANK_3 = 1
RANK_4 = 2
RANK_5 = 3
RANK_6 = 4
RANK_7 = 5
RANK_8 = 6
RANK_9 = 7
RANK_10 = 8
RANK_J = 9
RANK_Q = 10
RANK_K = 11
RANK_A = 12

; 
HAND_HIGH_CARD = 0
HAND_ONE_PAIR = 1
HAND_TWO_PAIR = 2
HAND_THREE_OF_A_KIND = 3
HAND_STRAIGHT = 4
HAND_FLUSH = 5
HAND_FULL_HOUSE = 6
HAND_FOUR_OF_A_KIND = 7
HAND_STRAIGHT_FLUSH = 8

; f[^ wb_
MONEY_COM = 0
MONEY_MAN = 1
PICTURE_START = 3
MSG_GAMEOVER = 4

; f[^ f[^
MONEY_CLEAR = 0
FACE_START = 1
MSG_START = 2
FACE_NORMAL = 3
FACE_SMILE = 4
FACE_SAD = 5
MSG_GAME = 6
MSG_PROMPT = 7
MSG_CHECK = 8
MSG_CALL = 9
MSG_BID = 10
MSG_RAISE = 11
MSG_FOLD = 12
MSG_WIN = 13
MSG_LOSE = 14
MSG_CLEAR = 15
PICTURE = 16
COM_DATA_SIZE = 17

; f[^ tb^
MONEY_ALLCLEAR = 0
FACE_ALLCLEAR = 1
MSG_ALLCLEAR = 2

; CY̍ől
MAX_BET = 5

.area _CODE

;
; Xe[WJnÕbZ[W\
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
game_start::
	ld A, #FACE_START
	ld (#face), A
	call scroll_mid
	ld A, #MSG_START
	jp pause_msg

;
; 1ΐ킷
;
; 
; Ȃ
;
; o
; A,BC,DE,HL,IX,IY,AF':j
; Cy:Xe[WNAłȂ, NC:Xe[WNA
; Z:Q[I[o[, NZ:Q[I[o[łȂ
;
game::
	; 
	ld HL, #0x0303
	ld (#changes), HL
	call dec_playstyle_count

	; bZ[W\(Q[JnO)
	ld A, #FACE_NORMAL
	ld (#face), A
	call scroll_mid
	ld A, #MSG_GAME
	call putmsg

	; NA\
	call check_clear
	jp NC, game_clear
	push AF
	ld DE, #0x0400
	ld HL, #msg_next
	call print
	pop AF
	call putnum
	call delay_long

	; AeB𕥂
	ld HL, #0x0101
	ld (#pot), HL
	call scroll_mid
	call delay_long

	; Dz
	call shuffle_card
	call deal_card10

	; Rs[^̖𓾂
	ld A, #1
	ld (#player), A
	call get_hand

	; D\()
	call put_card5_tail

	; lԂ̎D\
	xor A
	ld (#player), A
	call sort_card
	call put_card5
	call delay_short

	; 1ڂ̃C^[o
	call betting_interval_first
	jp Z, game_fold

	; D
	ld A, (#dealer)
	xor #1
	ld (#player), A
	call change
	call change

	; 2ڂ̃C^[o
	call betting_interval_second
	jp Z, game_fold

game_show:
	; V[_E
	call scroll_mid

	; lԂ̎\
	ld DE, #0x0400
	ld A, (#man_hand)
	call put_hand_name
	
	; Rs[^̎D\
	ld A, #1
	ld (#player), A
	call put_card5

	; Rs[^̎\
	ld DE, #0x0300
	ld A, (#com_hand)
	call put_hand_name
	call delay_longlong

game_cmp:
	; s𔻒肷
	call cmp_hand
	jp Z, game_tie
	jr NC, game_com_win

game_man_win:
	; lԂ̏
	ld DE, #man_money
	xor A
	jr game_last

game_com_win:
	; Rs[^̏
	ld DE, #com_money
	ld A, #1
game_last:
	ld (#dealer), A
	or A

	; q̂
	push AF
	ld HL, (#money)
	ld BC, (#pot)
	sbc HL, BC
	ld (#money), HL
	ex DE, HL
	ld A, (HL)
	add B
	add C
	ld (HL), A
	ld BC, #0x0000
	ld (#pot), BC
	pop AF

	; s\
	ld BC, #FACE_SAD * 0x100 + MSG_LOSE
	ld HL, #msg_lose
	ld DE, #msg_win
	jr Z, game_put_win_lose
	ld BC, #FACE_SMILE * 0x100 + MSG_WIN
	ex DE, HL
game_put_win_lose:
	push DE
	ld DE, #0x0105
	call print
	pop DE
	ex DE, HL
	ld DE, #0x0605
	call print

	; Rs[^tH[h?
	ld HL, #face
	ld A, (HL)
	cp #FACE_SAD
	jr NZ, game_com_msg_skip
	ld C, #MSG_FOLD
game_com_msg_skip:

	; s\
	ld A, B
	ld (HL), A
	call scroll_mid
	ld A, C
	call pause_msg

	; JE^ݒ肷
	ld A, (#man_changes)
	push AF
	ld HL, #change_init_value
	call get_table
	ld C, A
	pop AF

	ld HL, #playstyle_change0
	call add_hl_a
	ld (HL), C

	; Xe[WNA?
	call check_clear
	jr NC, game_clear

game_tie:
	; Q[I[o[?
	ld A, (#man_money)
	or A
	call Z, game_over
	scf
	ret

game_fold:
	; lԂtH[h?
	ld A, (#player)
	or A
	jr NZ, game_fold_com

game_fold_man:
	; lԂtH[h
	ld A, #4
	ld (#playstyle_fold), A
	jp game_com_win

game_fold_com:
	; q̍𓾂
	ld A, (#com_pot)
	ld B, A
	ld A, (#man_pot)
	sub B

	; 傫?
	cp #5
	jp C, game_man_win

	; ΋L^
	ld A, (#playstyle_high)
	add #3
	ld (#playstyle_high), A
	jp game_man_win

game_clear:
	; Xe[WNA
	ld A, #FACE_SAD
	ld (#face), A
	call scroll_mid
	ld A, #MSG_CLEAR
	call pause_msg

	; 摜\
	ld IX, (#stage)
	ld A, PICTURE(IX)
	call show_picture

	; ̃Xe[Wֈڂ
	ld HL, (#stage)
	ld BC, #COM_DATA_SIZE
	add HL, BC
	ld (#stage), HL

	; I[NA?
	ld A, (HL)
	inc A
	jr Z, game_all_clear
	ret

game_over:
	; Q[I[o[
	push AF

	ld HL, (#com_data_head)
	ld (#stage), HL
	ld A, #MSG_GAMEOVER
	call pause_msg

	pop AF
	ret

game_all_clear:
	; I[NA
	ld A, #FACE_ALLCLEAR
	ld (#face), A
	call scroll_mid
	ld A, #MSG_ALLCLEAR
	call pause_msg

	xor A
	scf
	ret

msg_win:
	.ascii /WIN!!!\0/
msg_lose:
	.ascii /LOSE..\0/
msg_next:
	.ascii /NEXT:\0/

;
; Xe[WNA?
;
; 
; Ȃ
;
; o
; A,HL:j
; Cy:Xe[WNAłȂ, NC:Xe[WNA
;
check_clear:
	; Xe[WNAz𓾂
	ld HL, (#stage)
	ld A, #MONEY_CLEAR
	call get_table

	; Rs[^̎Ɣr
	ld HL, #com_money
	cp (HL)
	ret

;
; xbeBOC^[o(O)
;
; 
; Ȃ
;
; o
; (#next_opener):̃C^[oōŏɃxbgvC[
; (#player):tH[hvC[
; Z:tH[h, NZ:tH[hȂ
; A,BC,DE,HL:j
;
betting_interval_first:
	; fB[[łȂvC[xbg
	ld C, #0
	ld A, (#dealer)
	xor #1
	jr betting_interval1

;
; xbeBOC^[o()
;
; 
; Ȃ
;
; o
; (#player):tH[hvC[
; Z:tH[h, NZ:tH[hȂ
; A,BC,DE,HL:j
;
betting_interval_second:
	; OxbgvC[xbg
	ld C, #1
	ld A, (#next_opener)

betting_interval1:
	; I[vi[̃xbg
	ld (#player), A
	ld (#next_opener), A
	call scroll_mid
	call bet1
	ret Z
	jr C, betting_interval2

	; I[vi[łȂvC[̃xbg(I[vi[`FbN)
	call flip_player
	call bet1
	ret Z
	jr C, betting_interval2

	; vC[Ƃ`FbN
	ret

betting_interval2:
	; ŏɃxbgvC[L^
	ld A, (#player)
	ld (#next_opener), A

betting_interval2_loop:
	; vC[ςăxbg
	call flip_player
	call bet2
	ret Z
	ret NC
	jr betting_interval2_loop

;
; I[vjOxbg
;
; 
; C:0.O, 1.
; (#player):vC[
;
; o
; Z:tH[h, NZ:tH[hłȂ
; Cy:CY, NC:R[
; A,DE,HL:j
;
bet1:
	push BC

	ld B, #0
	jr bet

;
; xbg
;
; 
; C:0.O, 1.
; (#player):vC[
;
; o
; Z:tH[h, NZ:tH[hłȂ
; Cy:CY, NC:R[
; A,DE,HL:j
;
bet2:
	push BC

	ld B, #1

bet:
	; ǂ̃xbg?
	ld A, (#player)
	or A
	jr NZ, bet_com

bet_man:
	; lԂ̃xbg
	call input_bet
	ld HL, #man_pot
	ld DE, #com_pot
	jr bet_skip

bet_com:
	; Rs[^̃xbg
	call think_bet
	ld HL, #com_pot
	ld DE, #man_pot
bet_skip:

	; tH[h?
	cp #-1
	jr Z, bet_fold

	; R[?
	or A
	ld B, A
	ld A, (DE)
	ld (HL), A
	ld A, B
	jr Z, bet_call

bet_raise:
	; CY
	add (HL)
	ld (HL), A
	scf
	jr bet_skip2
bet_call:
	; R[
	inc A
	or A
	jr bet_skip2
bet_fold:
	; tH[h
	xor A
bet_skip2:

	; q\
	push AF
	call scroll_mid
	pop AF
	
	pop BC
	ret

;
; Q[̏Ԃۑ
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
resume_game:
	call resume
	call cls
	call scroll_mid
	call put_card5_tail
	call put_card5

;
; xbg̓͂𓾂(l)
;
; 
; B:0.O, 1.
;
; o
; A:-1.tH[h, 0.R[, .CYz
; F,BC,DE,HL:j
;
input_bet:
	ld IX, #pat_check
	ld IY, #pat_bid
	inc B
	dec B
	jr Z, input_bet_skip
	ld IX, #pat_call
	ld IY, #pat_raise

input_bet_skip:
	ld A, #MSG_PROMPT
	call putmsg
	call put_call
	call put_raise
	call put_fold

input_bet_loop:
	call getkeyn
	cp #0x51 ; BREAK
	jr Z, resume_game
	cp #0x25 ; .
	jr Z, input_bet_fold
	call 0xbe56
	sub #"0"
	cp #MAX_BET + 1
	jr NC, input_bet_loop
	push IX
	push IY
	ld HL, #man_pot
	ld DE, #com_pot
	ld IX, #man_money
	ld IY, #com_money
	call check_bet
	pop IY
	pop IX
	jr NC, input_bet_loop

	call rmmsg
	push AF
	or A
	call Z, put_call
	pop AF

	push AF
	or A
	call NZ, put_raise
input_bet_last:
	call delay_longlong
	call rmmsg
	pop AF
	ret

input_bet_fold:
	ld A, #-1

	push AF
	call rmmsg
	call put_fold
	jr input_bet_last

put_call:
	ld DE, #0x0400
	ld HL, #pat_button0
	call putpat
	inc E
	push IX
	pop HL
	jp putpat

put_raise:
	ld DE, #0x0405
	ld HL, #pat_button19
	call putpat
	inc E
	inc E
	inc E
	push IY
	pop HL
	jp putpat

put_fold:
	ld DE, #0x040b
	ld HL, #pat_button_period
	call putpat
	inc E
	ld HL, #pat_fold
	jp putpat

;
; xbg(Rs[^)
;
; 
; B:0.I[vjOxbg, 1.I[vjOxbgłȂ
; C:0.O, 1.
;
; o
; A:-1.tH[h, 0.R[, .CYz
; F,BC,DE,HL:j
;
think_bet:
	ld IX, #com_money
	ld IY, #man_money
	ld HL, #com_pot
	ld DE, #man_pot

	; lԂnb^𑽗pĂƗސꍇ, O̓`FbN
	ld A, (#playstyle_high)
	cp #2
	jr C, think_bet_not_high2
	ld A, B
	or C
	jp Z, think_bet_last_call
	jr think_bet_skip
think_bet_not_high2:

	; I[vjOxbgłȂ?
	inc B
	dec B
	jr NZ, think_bet_skip2

	; lԂI[vjOxbg`FbN?
	ld A, (#next_opener)
	or A
	jr Z, think_bet_skip2

	; _Ń`FbN邩ȂI
	call rand
	cp #0x20
	jp C, think_bet_last_call
think_bet_skip2:

	; ut邩?
	ld L, #127
	call rand
	cp #0x20
	jr C, think_bet_call

	; ut邩? (lԂ悭tH[hĂȂutmグ)
	ld A, (#playstyle_fold)
	or A
	jr NZ, think_bet_skip
	call rand
	cp #0x20
	jr C, think_bet_call

think_bet_skip:
	; ڕWq𓾂
	call get_bet
.if 0
	; DEBUG ڕWq\
	push DE
	push HL
	ld DE, #0x0100
	ld A, H
	call putnum
	ld DE, #0x0104
	ld A, L
	call putnum
	pop HL
	pop DE
.endif

	; ڕWq̏𒴂?
	ld A, (#man_pot)
	cp H
	jr C, think_bet_call

	; I[vjOxbg?
	inc B
	dec B
	jr Z, think_bet_call

	; I[vjOxbgłȂ΃tH[h
	jr think_bet_last_fold

think_bet_call:
	; R[邩?
	ld A, (#man_pot)
	cp L
	jr NC, think_bet_last_call
	jr Z, think_bet_last_call
	ld A, #1
	call check_bet
	jr NC, think_bet_last_call

think_bet_raise:
	; CY̏߂
	ld A, (#man_pot)
	neg
	add L
	or A
	jr Z, think_bet_last_call
	jp M, think_bet_last_call
	ld L, A
	inc L

	; CY̊z߂
think_bet_loop:
	call rand
	and #0x07
	inc A
	jr Z, think_bet_loop
	cp #MAX_BET + 1
	jr NC, think_bet_loop
	cp L
	jr NC, think_bet_loop
	call check_bet
	jr NC, think_bet_loop
	jr Z, think_bet_last

think_bet_last:
	or A
	jr Z, think_bet_last_call

; CY
think_bet_last_raise:
	push AF
	ld A, #MSG_BID
	add B
	call popmsg
	pop AF
	ret

; R[
think_bet_last_call:
	ld A, #MSG_CHECK
	add B
	call popmsg
	xor A
	ret

; tH[h
think_bet_last_fold:
	ld A, #FACE_SAD
	ld (#face), A
	call scroll_mid
	ld A, #MSG_FOLD
	call popmsg
	ld A, #-1
	ret

;
; q̏ƖڕW𓾂
;
; 
; B:0.I[vjOxbg, 1.I[vjOxbgłȂ
; C:0.O, 1.
;
; o
; H:q̏
; L:q̖ڕW
; AF:j
;
get_bet:
	; ̕]l𓾂
	push BC
	call get_hand_value
	ld C, A

	; lԂ̌ŕ]l␳邩?
	ld HL, #playstyle_change0
	ld A, (#man_changes)
	ld B, A
	call get_table
	jr NZ, get_bet_skip1

	; lԂ̌ŕ]l␳
	ld HL, #table_eval_change
	ld A, B
	call get_table
	add C
	ld C, A
get_bet_skip1:
	ld A, C
	pop BC

	; ƂĂ肩?
	ld HL, #0x0201
	sub #HAND_HIGH_CARD * 13 + RANK_10
	ret M

	; ォ?
	inc C
	dec C
	ld HL, #0x3f28
	jr NZ, get_bet_skip2

	; O
	ld L, #0x14

	; ÕnCJ[h␳
	cp #0
	jr NC, get_bet_skip2
	add #6
get_bet_skip2:

	; ɂ悢肩?
	cp #(HAND_THREE_OF_A_KIND * 13 + RANK_A) - (HAND_HIGH_CARD * 13 + RANK_10)
	ret NC

	; ƂĂ悢肩?
	srl L
	cp #(HAND_TWO_PAIR * 13 + RANK_A) - (HAND_HIGH_CARD * 13 + RANK_10)
	ret NC

	; q𓾂
	ld HL, #bet_table
	call get_table2

.if 0
	; DEBUG ڕWq\
	push AF
	push DE
	push HL
	ld DE, #0x0100
	call putnum
	pop HL
	pop DE
	pop AF
.endif

	; lԂnb^𑽗pĂƐ邩?
	ld A, (#playstyle_high)
	cp #2
	ret C

	; q̏2{ɂ
	sla H
	ret

; lԂ̌ɂ]̕␳l
table_eval_change:
	.db #-13
	.db #-13
	.db #-7
	.db #0
	.db #3
	.db #6

; q\
bet_table:
	.dw 0x0301	; 10̃nCJ[h	0%
	.dw 0x0301	; J̃nCJ[h	1%
	.dw 0x0301	; Q̃nCJ[h	4%
	.dw 0x0401	; K̃nCJ[h	11%
	.dw 0x0401	; ÃnCJ[h	26%
	.dw 0x0501	; 2̃yA	29%
	.dw 0x0501	; 3̃yA	31%
	.dw 0x0501	; 4̃yA	34%
	.dw 0x0501	; 5̃yA	37%
	.dw 0x0601	; 6̃yA	40%
	.dw 0x0601	; 7̃yA	44%
	.dw 0x0904	; 8̃yA	48%
	.dw 0x0904	; 9̃yA	52%
	.dw 0x0a05	; 10̃yA	56%
	.dw 0x3f05	; J̃yA	61%
	.dw 0x3f05	; Q̃yA	66%
	.dw 0x3f07	; K̃yA	71%
	.dw 0x3f07	; ÃyA	76%
	.dw 0x3f07	; 2̃c[yA	76%
	.dw 0x3f07	; 3̃c[yA	77%
	.dw 0x3f07	; 4̃c[yA	77%
	.dw 0x3f07	; 5̃c[yA	77%
	.dw 0x3f08	; 6̃c[yA	78%
	.dw 0x3f09	; 7̃c[yA	79%
	.dw 0x3f0a	; 8̃c[yA	80%
	.dw 0x3f0a	; 9̃c[yA	81%
	.dw 0x3f0a	; 10̃c[yA	82%
	.dw 0x3f0a	; J̃c[yA	84%
	.dw 0x3f0a	; Q̃c[yA	85%
	.dw 0x3f0a	; K̃c[yA	87%
	.dw 0x3f0a	; Ãc[yA	90%

;
; Rs[^̎\1byte̒l𓾂
;
; 
; Ȃ
;
; o
; A:
; F:j
;
get_hand_value:
	push BC
	push HL

	ld HL, #com_hand
	ld A, (HL)
	ld C, A
	add A
	add A
	add A
	add C
	add C
	add C
	add C
	add C
	inc HL
	add (HL)

	ld HL, #com_style
	add (HL)

	pop HL
	pop BC
	ret

;
; q`FbN
;
; 
; A:-1.tH[h, 0.R[, .CYz
; HL:̓q
; IX:̎
; IY:̎
;
; o
; Cy:, NC:s
;
check_bet:
	push AF

	; R[?
	or A
	jr Z, check_bet_ok

	; tH[h?
	inc A
	jr Z, check_bet_ok
	dec A
	dec A

	; CYł邩?
	ex DE, HL
	add (HL)
	ex DE, HL
	cp (IX)
	jr NC, check_bet_ng
	cp (IY)
	jr NC, check_bet_ng

check_bet_ok:
	pop AF
	scf
	ret

check_bet_ng:
	pop AF
	or A
	ret

;
; D
;
; 
; (#player):vC[
;
; o
; (#player):ɌvC[
; AF,BC,DE,HL:j
;
change:
	; ǂ̃vC[邩?
	ld A, (#player)
	or A
	jr NZ, change_com

change_man:
	; lԑɃXN[
	call scroll_man

	; D̂Ă
	call input_discard
	call put_card5
	call delay_long

	; D[
	call change_card
	call put_card5
	call delay_long
	call sort_card
	call put_card5

	; \
	call get_hand
	ld DE, #0x0400
	ld A, (#man_hand)
	call put_hand_name
	call delay_long
	jr change_last

change_com:
	; Rs[^ɃXN[
	call scroll_com
	call delay_long

	; D̂Ă
	call sort_card
	call get_hand
	call think_discard
	ld A, #5
	sub B

	; ̂Ă̎D\
	ld B, A
	ld DE, #0x0000
	call put_card_tail_n
	call delay_long
	call delay_short

	; [̎D\
	ld B, #5
	ld DE, #0x0000
	call put_card_tail_n
	call delay_long

	; D[
	call change_card
	call sort_card
	call get_hand

change_last:
	; vC[؂ւ
	call flip_player

	; ɃXN[
	jp delay_mid

;
; ̂ĂD̓͂𓾂(l)
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
input_discard:
	; HOLD̑I
	ld HL, #hold_mark
	ld BC, #5
	call memclr

input_discard_loop:
	; HOLD}[N\
	ld DE, #0x0400
	ld HL, #hold_mark
	ld B, #5
input_discard_loop2:
	push BC
	push HL
	inc (HL)
	dec (HL)
	call put_hold
	pop HL
	pop BC
	inc E
	inc E
	inc E
	inc HL
	djnz input_discard_loop2

input_discard_redo:
	; L[͂𓾂
	call getkeyn
	;cp #0x51 ; BREAK
	;jp Z, 0x0000
	cp #0x28 ; RETURN
	jr Z, input_discard_discard
	call 0xbe56
	sub #"1"
	cp #5
	jr NC, input_discard_redo

	; HOLDԂݒ/
	ld HL, #hold_mark
	call add_hl_a
	ld A, #1
	xor (HL)
	ld (HL), A
	jr input_discard_loop

input_discard_discard:
	; D̂Ă
	ld DE, #man_card
	ld HL, #hold_mark
	ld BC, #0x0500
input_discard_loop3:
	inc (HL)
	dec (HL)
	jr NZ, input_discard_skip
	ld A, #0xff
	ld (DE), A
	inc C
input_discard_skip:
	inc DE
	inc HL
	djnz input_discard_loop3

	; L^
	ld A, C
	ld (#man_changes), A

	; HOLD}[N
	ld DE, #0x0400
	ld B, #15
	jr jp_rmpat

put_hold:
	ld HL, #pat_hold
	jr Z, put_hold_rm
	jp putpat

put_hold_rm:
	ld B, #3
jp_rmpat:
	jp rmpat

;
; JE^S1炷
;
; 
; Ȃ
;
; o
; HL:j
;
dec_playstyle_count:
	ld HL, #playstyle_change0 - 1
	call dec_playstyle_count1
dec_playstyle_count6:
	call dec_playstyle_count2
dec_playstyle_count4:
	call dec_playstyle_count2
dec_playstyle_count2:
	call dec_playstyle_count1
dec_playstyle_count1:
	inc HL
	dec (HL)
	ret P
	ld (HL), #0
	ret

;
; D̂Ă(Rs[^)
;
; 
; Ȃ
;
; o
; A:
; F,BC,HL:j
;
think_discard:
	; 閇𓾂
	ld A, (#com_hand)
	ld HL, #think_discard_table
	call get_table2
	call call_hl

	; ̂ĂL^
	ld (#com_changes), A

	; D̂Ă
	or A
	ret Z
	ld C, A
	ld B, #0
	ld HL, #com_hand + 5
think_discard_loop:
	ld A, (HL)
	call discard_rank
	ld A, B
	adc #0
	ld B, A
	cp C
	dec HL
	jr NZ, think_discard_loop
	ret

think_discard_high_card:
	; nCJ[ĥƂ
	ld A, (#playstyle_high)
	cp #4
	jr NC, think_discard3
	ld A, (#com_pot)
	cp #6
	jr NC, think_discard2
	ld A, (#com_hand + 3) ; 3ԖڂɍN
	cp #RANK_9
	jr NC, think_discard2
think_discard3:
	ld A, #3
	ret

think_discard_one_pair:
	; yÂƂ
	ld A, (#playstyle_high)
	cp #4
	jr NC, think_discard3
	call rand
	cp #5
	jr C, think_discard0
	cp #10
	jr C, think_discard1
	ld A, (#com_pot)
	cp #6
	jr NC, think_discard2
	ld A, (#com_hand + 2) ; yAłȂ̃N
	cp #RANK_8
	jr NC, think_discard3
think_discard2:
	ld A, #2
	ret
think_discard1:
	ld A, #1
	ret

think_discard_three_of_a_kind:
	; X[EIuEAEJCĥƂ
	call rand
	and #0x80
	jr Z, think_discard2
think_discard_four_of_a_kind:
	; tH[EIuEAEJCĥƂ
think_discard_two_pair:
	; c[yÂƂ
	call rand
	and #0x80
	jr Z, think_discard1

think_discard_straight:
	; Xg[ĝƂ
think_discard_flush:
	; tbV̂Ƃ
think_discard_full_house:
	; tnEX̂Ƃ
think_discard_straight_flush:
	; Xg[gtbV̂Ƃ
think_discard0:
	xor A
	ret

think_discard_table:
	.dw think_discard_high_card
	.dw think_discard_one_pair
	.dw think_discard_two_pair
	.dw think_discard_three_of_a_kind
	.dw think_discard_straight
	.dw think_discard_flush
	.dw think_discard_full_house
	.dw think_discard_four_of_a_kind
	.dw think_discard_straight_flush

;
; D̂Ă(Rs[^)
;
; 
; A:N
;
; o
; Cy:D̂Ă, NC:̂ĂȂ
; AF:j
;
discard_rank:
	push BC
	push HL

	ld HL, #com_card
	ld C, A
	ld B, #5

discard_rank_loop:
	; Nv邩?
	ld A, (HL)
	call get_rank
	cp C
	jr NZ, discard_rank_skip

	; vD̂Ă
	ld (HL), #0xff
	scf
	jr discard_rank_last

discard_rank_skip:
	inc HL
	djnz discard_rank_loop

	; vDȂ
	or A

discard_rank_last:
	pop HL
	pop BC
	ret

;
; ̂ĂJ[h[
;
; 
; (#player):vC[
;
; o
; AF,BC,DE,HL:j
;
change_card:
	call get_card_address

	ld B, #5
change_card_loop:
	ld A, (HL)
	cp #0xff
	call Z, draw_card
	inc HL
	djnz change_card_loop
	ret

;
; Vbt
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
shuffle_card::
	ld B, #52
	ld DE, #pile
shuffle_card_loop:
	call rand
	rrca
	rrca
	cp #52
	jr NC, shuffle_card_loop
	ld HL, #pile
	call add_hl_a
	call ex_de_hl
	inc DE
	djnz shuffle_card_loop

	ld HL, #pile
	ld (#pile_top), HL
	ret

;
; lԂƃRs[^ɎDz
;
; 
; Ȃ
;
; o
; AF, HL:j
;
deal_card10:
	push BC

	ld HL, #man_card
	ld B, #10
deal_card10_loop:
	call draw_card
	inc HL
	djnz deal_card10_loop

	pop BC
	ret

;
; DɃ\[g
;
; 
; (#player):vC[
;
; o
; AF,BC,DE,HL:j
;
sort_card:
	call get_card_address

	ld B, #5
sort_card_loop2:
	ld D, H
	ld E, L

	push BC
sort_card_loop:
	ld A, (DE)
	cp (HL)
	call C, ex_de_hl
	inc DE
	djnz sort_card_loop
	pop BC

	inc HL
	djnz sort_card_loop2
	ret

;
; RD1
;
; 
; HL:DރAhX
;
; o
; A:D
;
draw_card:
	push HL
	ld HL, (#pile_top)
	ld A, (HL)
	inc HL
	ld (#pile_top), HL
	pop HL

	ld (HL), A
	ret

;
; r
;
; 
; Ȃ
;
; o
; Cy:Rs[^̏ NC:lԂ̏
; Z:, NZ:ł͂Ȃ
; A,BC,DE,HL:j
;
cmp_hand:
	ld HL, #man_hand
	ld DE, #com_hand
	ld B, #6

com_hand_loop:
	ld A, (DE)
	cp (HL)
	ret NZ
	inc HL
	inc DE
	djnz com_hand_loop
	ret

;
; 𓾂
;
; 
; (#player):vC[
;
; o
; AF,BC,DE,HL:j
;
get_hand:
	call get_card_hand_address

	push HL
	push DE
	push HL

	; 
	ld BC, #6
	ex DE, HL
	ld A, #0xff
	call memset

	; Ɨ̈
	ld BC, #13 + 4 + 1 + 1 + 4
	ld HL, #rank
	call memclr
	
	pop DE

	; NEX[gƂ̖𓾂
	ld B, #5
get_hand_histgram_loop:
	ld A, (DE)
	call get_rank
	ld HL, #rank
	call add_hl_a
	inc (HL)

	ld A, (DE)
	call get_suit
	ld HL, #suit
	call add_hl_a
	inc (HL)

	inc DE
	djnz get_hand_histgram_loop

	ld A, (#rank + 12)
	ld (#rank - 1), A

	; tbV?
	ld A, #5
	ld BC, #4
	ld HL, #suit
	cpir
	jr NZ, get_hand_flush_skip
	ld (#flush), A
get_hand_flush_skip:

	; Xg[g?
	ld HL, #rank + 12
	ld C, #10
get_hand_straight_loop:
	ld D, H
	ld E, L
	ld B, #5
get_hand_straight_loop2:
	ld A, (DE)
	cp #1
	jr NZ, get_hand_straight_skip
	dec DE
	djnz get_hand_straight_loop2
	ld A, C
	add #2
	ld (#straight), A
get_hand_straight_skip:
	dec HL
	dec C
	jr NZ, get_hand_straight_loop

	pop DE

	; yA𓾂
	push DE
	ld HL, #four
	ld C, #4
get_hand_count_loop2:
	ld IX, #rank + 12
	ld B, #13
get_hand_count_loop:
	ld A, (IX)
	dec IX
	cp C
	jr NZ, get_hand_count_skip
	inc (HL)
	inc DE
	ld A, B
	dec A
	ld (DE), A
get_hand_count_skip:
	djnz get_hand_count_loop
	inc HL
	dec C
	jr NZ, get_hand_count_loop2
	pop HL

	pop DE

	; Xg[gtbV?
	ld A, (#straight)
	or A
	jr Z, get_hand_not_straight_flush
	ld A, (#flush)
	or A
	ld (HL), #HAND_STRAIGHT_FLUSH
	jr NZ, get_hand_straight
get_hand_not_straight_flush:

	; tH[EIuEAEJCh?
	ld A, (#four)
	or A
	ld (HL), #HAND_FOUR_OF_A_KIND
	ret NZ

	; tnEX?
	ld A, (#three)
	or A
	jr Z, get_hand_not_full_house
	ld A, (#two)
	or A
	ld (HL), #HAND_FULL_HOUSE
	ret NZ
get_hand_not_full_house:

	; tbV?
	ld A, (#flush)
	or A
	ld (HL), #HAND_FLUSH
	jr NZ, get_hand_last

	; Xg[g?
	ld A, (#straight)
	or A
	ld (HL), #HAND_STRAIGHT
	jr NZ, get_hand_straight

	; X[EIuEAEJCh?
	ld A, (#three)
	or A
	ld (HL), #HAND_THREE_OF_A_KIND
	ret NZ

	; c[yA?
	ld A, (#two)
	cp #2
	ld (HL), #HAND_TWO_PAIR
	ret Z

	; yA?
	ld A, (#two)
	or A
	ld (HL), #HAND_ONE_PAIR
	ret NZ

	; nCJ[h
	ld (HL), #HAND_HIGH_CARD
get_hand_last:
	inc HL

	; N~ɏ
	ld B, #5
	inc DE
	inc DE
	inc DE
	inc DE
get_hand_last_loop:
	ld A, (DE)
	dec DE
	call get_rank
	ld (HL), A
	inc HL
	djnz get_hand_last_loop
	ret

get_hand_straight:
	; Xg[g̖
	ld A, (#straight)
	inc HL
	ld (HL), A
	ret

;
; vC[ɂ
;
; 
; (#player):vC[
;
; o
; (#player):̃vC[
; HL:j
;
flip_player:
	push AF

	ld HL, #player
	ld A, (HL)
	xor #1
	ld (HL), A

	pop AF
	ret

;
; D̃AhXƕ\ʒu𓾂
;
; 
; (#player):vC[
;
; o
; DE:\ʒu
; HL:D̐擪AhX
; F:j
;
get_card_address:
	ld DE, #0x0500
	ld HL, #man_card
	ld A, (#player)
	or A
	ret Z

	ld D, #0
	ld HL, #com_card
	ret

;
; DƖ̃AhX𓾂
;
; 
; (#player):vC[
;
; o
; DE:̐擪AhX
; HL:D̐擪AhX
; F:j
;
get_card_hand_address:
	call get_card_address

	ld DE, #man_hand
	ret Z
	ld DE, #com_hand
	ret

;
; bZ[W\
;
; 
; A:bZ[Wԍ
;
; o
; AF:j
;
putmsg:
	call rmmsg

	;push DE
	push HL
	
	call get_address
	ld DE, #0x0300
	call printknj
	
	pop HL
	;pop DE
	ret

;
; bZ[W莞ԕ\
;
; 
; A:bZ[Wԍ
;
; o
; AF:j
;
popmsg:
	call putmsg
	call delay_longlong

;
; bZ[W
;
; 
; Ȃ
;
; o
; Ȃ
;
rmmsg:
	push AF
	push BC
	push DE
	push HL

	ld BC, #0x0f02
	ld DE, #0x0300
	call rmrect

	pop HL
	pop DE
	pop BC
	pop AF
	ret

;
; ̖O\
;
; 
; A:
; DE:ʒu
;
; o
; AF,DE,HL:j
;
put_hand_name:
	push HL

	ld HL, #hand_name_table
	call get_table2
	call print

	pop HL
	ret

hand_name_table:
	.dw #hand_name_high_card
	.dw #hand_name_one_pair
	.dw #hand_name_two_pair
	.dw #hand_name_three_of_a_kind
	.dw #hand_name_straight
	.dw #hand_name_flush
	.dw #hand_name_full_house
	.dw #hand_name_four_of_a_kind
	.dw #hand_name_straight_flush

hand_name_high_card:
	.ascii /HIGH CARD\0/
hand_name_one_pair:
	.ascii /1 PAIR\0/
hand_name_two_pair:
	.ascii /2 PAIR\0/
hand_name_three_of_a_kind:
	.ascii /3 OF A KIND\0/
hand_name_straight:
	.ascii /STRAIGHT\0/
hand_name_full_house:
	.ascii /FULL HOUSE\0/
hand_name_four_of_a_kind:
	.ascii /4 OF A KIND\0/
hand_name_straight_flush:
	.ascii /STRAIGHT /
hand_name_flush:
	.ascii /FLUSH\0/

;
; D̃N𓾂
;
; 
; A:D
;
; o
; A:N
; F:j
;
get_rank:
	rrca
	rrca
	rrca
	rrca

;
; D̃X[g𓾂
;
; 
; A:D
;
; o
; A:X[g
; F:j
;
get_suit:
	and #0x0f
	ret

;
; ʂ𒆉ɃXN[
;
; 
; Ȃ
;
; o
; AF:j
;
scroll_mid:
	ld A, #8
	jr scroll

;
; ʂRs[^ɃXN[
;
; 
; Ȃ
;
; o
; AF:j
;
scroll_com:
	xor A
	jr scroll

;
; ʂlԑɃXN[
;
; 
; Ȃ
;
; o
; AF:j
;
scroll_man:
	ld A, #16
scroll:
	call settop

;
; Q[̏Ԃ\
;
; 
; Ȃ
;
; o
; AF:j
;
put_status:
	push BC
	push DE
	push HL
	
	; Ԃ̕\
	ld BC, #0x0908
	ld DE, #0x000f
	call rmrect

	; Rs[^̏Ԃ\
	ld E, #0x10
	rrca
	rrca
	rrca
	ld D, A
	push AF
	ld A, (#com_pot)
	push AF
	call putnum
	ld HL, #msg_slash
	call print
	pop AF
	neg
	ld HL, #com_money
	add (HL)
	call putnum
	pop AF
	inc D

	; OtBbN\
	ld A, (#face)
	call put_face

	; lԑ̏Ԃ\
	ld E, #0x10
	ld A, (#man_pot)
	push AF
	call putnum
	ld HL, #msg_slash
	call print
	pop AF
	neg
	ld HL, #man_money
	add (HL)
	call putnum

	pop HL
	pop DE
	pop BC
	ret

msg_slash:
	.ascii / \/ \0/

;
; ̎D\
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
put_card5_tail:
	ld B, #5
	ld E, #0
game_deal_loop:
	ld A, #0xfe
	ld D, #5
	call put_card
	ld D, #0
	call put_card
	call delay_short
	inc E
	inc E
	inc E
	djnz game_deal_loop
	ret

;
; D\
;
; 
; (#player):vC[
;
; o
; AF,BC,DE,HL:j
;
put_card5:
	call get_card_address

	ld B, #5
put_card5_loop:
	call put_card_hl
	djnz put_card5_loop
	ret

;
; D\(AhXw)
;
; 
; DE:ʒu
; HL:D̃AhX
;
; o
; AF:j
; DE:̈ʒu
; HL:̎D̃AhX
;
put_card_hl:
	ld A, (HL)
	call put_card
	inc HL
	inc E
	inc E
	inc E
	ret

;
; ̎D\
;
; 
; B:
; DE:ʒu
;
; o
; AF,DE:j
;
put_card_tail_n:
	push BC
	push DE
	
	ld BC, #0x0f03
	call rmrect
	
	pop DE
	pop BC

put_card_tail_n_loop:
	ld A, #0xfe
	call put_card
	inc E
	inc E
	inc E
	djnz put_card_tail_n_loop
	ret

;
; D\
;
; 
; A:D
; DE:ʒu
;
; o
; Ȃ
;
put_card::
	push AF
	push BC
	push DE
	push HL

	cp #0xfe
	jr Z, put_card_tail
	cp #0xff
	jr Z, put_card_clear

	; NƃX[g𓾂
	push AF
	call get_suit
	ld C, A
	pop AF
	call get_rank
	ld B, A

	; g\
	ld HL, #pat_card
	call putpat

	push HL

	; N\
	ld HL, #table_rank
	ld A, B
	call get_table2
	call putpat

	; X[g\
	inc D
	ld HL, #table_suit
	ld A, C
	call get_table2
	call putpat

	pop HL

	; g\
	inc D
	call putpat

	; N\
	inc E
	inc E
	ld A, B
	ld HL, #table_rank_rev
	call get_table2
	call putpat
	
put_card_last:
	pop HL
	pop DE
	pop BC
	pop AF
	ret

put_card_tail:
	ld HL, #pat_card_tail
	call putpat3
	jr put_card_last

put_card_clear:
	ld BC, #0x303
	call rmrect
	jr put_card_last

table_rank:
	.dw #pat_two
	.dw #pat_three
	.dw #pat_four
	.dw #pat_five
	.dw #pat_six
	.dw #pat_seven
	.dw #pat_eight
	.dw #pat_nine
	.dw #pat_ten
	.dw #pat_jack
	.dw #pat_queen
	.dw #pat_king
	.dw #pat_ace

table_rank_rev:
	.dw #pat_two_rev
	.dw #pat_three_rev
	.dw #pat_four_rev
	.dw #pat_five_rev
	.dw #pat_six_rev
	.dw #pat_seven_rev
	.dw #pat_eight_rev
	.dw #pat_nine_rev
	.dw #pat_ten_rev
	.dw #pat_jack_rev
	.dw #pat_queen_rev
	.dw #pat_king_rev
	.dw #pat_ace_rev

table_suit:
	.dw #pat_spade
	.dw #pat_heart
	.dw #pat_diamond
	.dw #pat_club

;
; OtBbN\
;
; 
; A:
;
; o
; AF,BC,HL:j
; D:̈ʒu
;
put_face:
	call get_address
	ld E, #0x0f

;
; p^[\
;
; 
; DE:ʒu
; HL:p^[
;
; o
; AF:j
; D:̈ʒu
;
putpat4::
	call putpat1
putpat3::
	call putpat1
putpat2::
	call putpat1
putpat1::
	call putpat
	inc D
	ret

;
; ̈
;
; 
; BC:ƍ
; DE:ʒu
;
; o
; AF:j
;
rmrect:
	push BC
	push DE

rmrect_loop:
	call rmpat
	inc D
	dec C
	jr NZ, rmrect_loop

	pop DE
	pop BC
	ret

;
; 摜\
;
; 
; A:摜
;
; o
; AF,BC,DE,HL:j
;
show_picture::
	ld HL, #index
	call get_table2
	call show
	jp cls

;
; ҂(Z)
;
; 
; Ȃ
;
; o
; AF:j
;
delay_short::
	ld A, #4
	jr jp_delay

;
; ҂()
;
; 
; Ȃ
;
; o
; AF:j
;
delay_mid::
	ld A, #8
	jr jp_delay

;
; ҂(ɒ)
;
; 
; Ȃ
;
; o
; AF:j
;
delay_longlong::
	call delay_long

;
; ҂()
;
; 
; Ȃ
;
; o
; AF:j
;
delay_long::
	ld A, #16
jp_delay:
	jp delay

;
; bZ[W\|[Y
;
; 
; A:bZ[W
;
; o
; AF,BC,DE,HL:j
;
pause_msg:
	call putmsg

	cp #20
	jr C, pause

	ld DE, #0x050b
	jr pause_msg_skip

;
; |[Y
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
pause::
	ld DE, #0x040b
pause_msg_skip:
	ld HL, #pat_button_ret
	call putpat

pause_loop:
	call rand
	call peekkey
	cp #0x28
	jr Z, pause_skip
	jr pause_loop

pause_skip:
	ld B, #3
	call rmpat

	push AF
pause_loop2:
	call peekkey
	jr C, pause_loop2
	pop AF
	ret

;
; \(0߂)
;
; 
; A:l
;
; o
; AF:j
; DE:̈ʒu
;
putnum_pad:
	push HL
	ld L, #1
	jr putnum2

;
; \(0߂Ȃ)
;
; 
; A:l
;
; o
; AF:j
; DE:̈ʒu
;
putnum:
	or A
	jr Z, putnum0

	push HL
	ld L, #0
putnum2:
	push BC

	ld C, #100
	call putnum1
	ld C, #10
	call putnum1
	ld C, #1
	call putnum1

	pop BC
	pop HL
	ret

putnum1:
	; w肳ꂽ̐𓾂
	ld B, #"0" - 1
putnum1_loop:
	inc B
	sub C
	jr NC, putnum1_loop
	add C

	push AF

	; \
	ld A, B
	cp #"0"
	jr Z, putnum1_skip
	ld L, #1
putnum1_skip:
	call putchr

	; ̌ɕ\ʒuڂ
	ld A, E
	add L
	ld E, A

	pop AF
	ret

putnum0:
	ld A, #"0"
	call putchr
	inc E
	ret

;
; call (HL)
;
; 
; HL:AhX
;
; o
; Ȃ
;
call_hl:
	jp (HL)

;
; ex (DE), (HL)
;
; 
; DE:AhX1
; HL:AhX2
;
; o
; A:j
;
ex_de_hl:
	ld A, (HL)
	push AF
	ld A, (DE)
	ld (HL), A
	pop AF
	ld (DE), A
	ret

;
; ld A, (HL + A)
;
; 
; A:CfbNX
; HL:擪AhX
;
; o
; A:(HL + A)
; HL:HL + A
;
get_table::
	call add_hl_a
	ld A, (HL)
	or A
	ret

;
; f[^̃AhX𓾂
;
; 
; A:CfbNXԍ
;
; o
; HL:AhX
; AF:j
;
get_address:
	ld HL, (#stage)
	call get_table
	ld HL, #index

;
; ld HL, (HL + 2 * A)
;
; 
; A:CfbNX
; HL:擪AhX
;
; o
; HL:(HL + A * 2)
; AF:j
;
get_table2::
	call add_hl_a
	call add_hl_a
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A
	ret

;
; add HL, A
;
; 
; A:l1
; HL:l2
;
; o
; HL:HL + A
; F:j
;
add_hl_a:
	push BC

	ld B, #0
	ld C, A
	add HL, BC

	pop BC
	ret

;
; NA
;
; 
; BC:
; HL:AhX
;
; o
; AF,BC,HL:j
;
memclr:
	xor A

;
; ɒl
;
; 
; A:l
; BC:
; HL:AhX
;
; o
; AF,BC,HL:j
;
memset:
	push DE

	dec BC
	ld D, H
	ld E, L
	inc DE
	ld (HL), A
	ldir

	pop DE
	ret

;
; ۑKvȃf[^
;

; RD
pile:
	.db 0x00, 0x01, 0x02, 0x03
	.db 0x10, 0x11, 0x12, 0x13
	.db 0x20, 0x21, 0x22, 0x23
	.db 0x30, 0x31, 0x32, 0x33
	.db 0x40, 0x41, 0x42, 0x43
	.db 0x50, 0x51, 0x52, 0x53
	.db 0x60, 0x61, 0x62, 0x63
	.db 0x70, 0x71, 0x72, 0x73
	.db 0x80, 0x81, 0x82, 0x83
	.db 0x90, 0x91, 0x92, 0x93
	.db 0xa0, 0xa1, 0xa2, 0xa3
	.db 0xb0, 0xb1, 0xb2, 0xb3
	.db 0xc0, 0xc1, 0xc2, 0xc3

; JE^l
change_init_value:
	.db 10	; Ȃ
	.db 10	; 1
	.db 15	; 2
	.db 0	; 3
	.db 0	; 4
	.db 0	; 5

; v[X^C ȂJE^
; (lԂȂƂlݒ肳.)
; (1Q[ƂɃJE^͌Z.)
; (JE^0̂Ƃ̕]l␳. ȉ.)
playstyle_change0:
	.db 0
; v[X^C 1JE^
playstyle_change1:
	.db 0
; v[X^C 2JE^
playstyle_change2:
	.db 10
; v[X^C 3JE^
playstyle_change3:
	.db 0
; v[X^C 4JE^
playstyle_change4:
	.db 0
; v[X^C 5JE^
playstyle_change5:
	.db 0
; v[X^C z̓q? (nb^p)
playstyle_high:
	.db 2
; v[X^C tH[h?
playstyle_fold:
	.db 0

; s̃vC[
player:
	.ds 1

; 2ڂ̃C^[oōŏɓqvC[
next_opener:
	.ds 2

; lԂ̓q
pot:
man_pot:
	.ds 1

; Rs[^̓q
com_pot:
	.ds 1

; lԂ̎D
man_card:
	.ds 5

; Rs[^̎D
com_card:
	.ds 5

; lԂ̖
man_hand:
	.ds 6

; Rs[^̖
com_hand:
	.ds 6

; lԂ
changes:
man_changes:
	.ds 1

; Rs[^
com_changes:
	.ds 1

; RD̐擪
pile_top::
	.ds 2

; OtBbN
face:
	.ds 1

; fB[[
dealer::
	.ds 1

; 
money::
; lԂ̎
man_money::
	.ds 1
; Rs[^̎
com_money::
	.ds 1

; Rs[^̃v[X^C
com_style::
	.ds 1

; Xe[W̃|C^
stage::
	.ds 2

;
; Ɨ̈
;
.area _HEADER(ABS)
.org 0x7f80

buf:
hold_mark: ; HOLD}[N
	.ds 1
rank: ; N\
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
	.ds 1
suit: ; X[g\
	.ds 1
	.ds 1
	.ds 1
	.ds 1
flush: ; tbV?
	.ds 1
straight: ; Xg[g̖̃N
	.ds 1
four: ; 4g݂̐
	.ds 1
three: ; 3g݂̐
	.ds 1
two: ; 2g݂̐
	.ds 1
one: ; 1̐
	.ds 1

;
; ΐ푊f[^
;
.org 0x1280

kanjifont::	; tHg
	.ds 2
com_data_head::	; ΐ푊f[^wb_
	.ds 2
com_data_body::	; ΐ푊f[^
	.ds 2
index::	; CfbNX\

;
; f[^
;
.area _DATA

; Copyright 2011, 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
