;
; \Tu[`
;

.area _CODE

WIDTH = 90

;
; 1\
;
; 
; A:
; DE:ʒu
;
; o
; AF:j
; DE:̈ʒu
;
putknj::
	push BC
	push HL

	ld B, #0
	ld C, A

	; tHgp^[̐擪ݒ肷
	ld HL, (#kanjifont)
	call a7_init

	; tHgp^[̃AhX𓾂
	ld H, B
	ld L, C
	add HL, HL
	add HL, HL
	add HL, HL
	or A
	sbc HL, BC

	; YWݒ肷
	ld BC, #0x0740
putknj_loop2:
	in A, (C)
	rlca
	jr C, putknj_loop2

	ld A, D
	or #0xb0
	out (C), A

	; XWݒ肷
	ld A, E
	and #0x0f
	out (C), A
	ld A, E
	rrca
	rrca
	rrca
	rrca
	and #0x0f
	or #0x10
	out (C), A

	; tHgp^[̃AhXݒ肷
	call a7_set
	inc C
putknj_loop:
	call a7_read
	out (C), A
	inc E
	djnz putknj_loop
	xor A
	out (C), A
	inc E

	; s?
	ld A, E
	cp #WIDTH - 8
	jr C, putknj_skip
	ld E, #0
	inc D
putknj_skip:

	pop HL
	pop BC
	ret

;
; ̕\
;
; 
; DE:ʒu
; HL:̐擪
;
; o
; F,BC:j
; A:\
; DE:̈ʒu
;
printknj::
	ld B, (HL)
	ld C, B
printknj_loop:
	inc HL
	ld A, (HL)
	call putknj
	djnz printknj_loop

	ld A, C
	ret

; Copyright 2011, 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
