;
; 7bitz
;

.area _CODE

;
; 
; HL:ZOgAhX
;
; o
; AF,HL:j
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
a7_init::
	ld (#a7_base), HL
	ld HL, #0

;
; ItZbgAhXݒ肷
;
; 
; HL:ItZbgAhX
; (#a7_base):ZOg
;
; o
; AF,HL:j
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
a7_set::
	push BC

	ld (#a7_off), HL

	ld A, L
	and #0x07
	inc A

	srl H
	rr L
	srl H
	rr L
	srl H
	rr L
	ld C, L
	ld B, H
	add HL, HL
	add HL, HL
	add HL, HL
	or A
	sbc HL, BC

	ld BC, (#a7_base)
	add HL, BC
	ld (#a7_address), HL

	ld B, A
	ld HL, #a7_mask
	ld (HL), #0x80
a7_set_loop:
	rlc (HL)
	djnz a7_set_loop

	pop BC
	ret

;
; l𓾂
;
; 
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
; o
; F:j
; A:l
; (#a7_address):̃AhX
; (#a7_mask):̃}XN
; (#a7_off):̃ItZbg
;
a7_read::
	push BC
	push DE
	push HL

	ld HL, (#a7_address)
	ld A, (#a7_mask)
	ld D, A
	ld BC, #0x0700

a7_read_loop:
	ld A, D
	and (HL)
	jr Z, a7_read_skip
	scf
a7_read_skip:
	rl C
	inc HL
	djnz a7_read_loop

	ld A, C
	pop HL
	pop DE
	pop BC

;
; AhXɐi߂
;
; 
; (#a7_base):ZOg
; (#a7_address):AhX
; (#a7_mask):}XN
; (#a7_off):ItZbg
;
; o
; F:j
; (#a7_address):̃AhX
; (#a7_mask):̃}XN
; (#a7_off):̃ItZbg
;
a7_next::
	push HL

	ld HL, (#a7_off)
	inc HL
	ld (#a7_off), HL

	ld HL, #a7_mask
	rlc (HL)
	jr NC, a7_next_last

	push BC
	ld HL, (#a7_address)
	ld BC, #7
	add HL, BC
	ld (#a7_address), HL
	pop BC

a7_next_last:
	pop HL
	ret

.area _DATA

a7_base::
	.ds 2
a7_address::
	.ds 2
a7_mask::
	.ds 1
a7_off::
	.ds 2

; Copyright 2011 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
