;
; k摜\
;

.area _CODE

resume_show::
	call resume
	jr show_restore

;
; k摜\
;
; 
; HL:k摜̃AhX
;
; o
; AF,BC,DE,HL:j
;
show::
	; L[𗣂܂ő҂
	ld A, #0xff
	call delay
	jr NZ, show

	; (hbg)𓾂
	ld A, (HL)
	sub #48
	ld (#height), A
	inc HL

	; (s)𓾂
	ld A, (HL)
	ld (#height2), A
	inc HL

	; \ʒu𓾂
	ld A, (HL)
	ld (#pos), A
	inc HL

show_loop:
	push HL

show_restore:
	; BREAKL[ꂽ?
	in A, (#0x1f)
	rlca
	jp C, resume_show

	; f[^̐擪𓾂
	ld A, (#pos)
	push AF
	rrca
	rrca
	rrca
	and #0x1f
	add A
	ld C, A
	ld B, #0
	add HL, BC

	; o̓|[gݒ肷
	ld C, #0x40

show_wait:
	; VRAMANZX\ɂȂ܂ő҂
	in A, (C)
	rlca
	jr C, show_wait

	; \擪ʒuݒ肷
	pop AF
	and #0x07
	or #0x40
	out (C), A

	; v[0\
	call show0
	call show0
	call show0

	; v[1\
	call show1
	call show1

	pop HL

	and #0x80
	jr Z, show_loop
	ret

;
; k摜̃v[1\
;
; 
; C:0x40
; HL:k摜̐擪
;
; o
; AF,B,DE:j
;
show1:
	ld A, (#height2)
	jr show0_skip

;
; k摜̃v[0\
;
; 
; A:s
; C:0x40
; HL:k摜̐擪
;
; o
; AF,B,DE:j
;
show0:
	xor A
	xor A
	jr show0_skip

show0_skip:
	push HL
	push BC

	push BC
	ld B, #0
	ld C, A
	add HL, BC
	pop BC

	; ҂Ԃ
	ld D, #1

	; 1v[\
	ld A, #0xb0
	call put_line
	call put_line
	call put_line
	call put_line
	call put_line
	call put_line
	call put_line

	; ҂
	ld HL, #pos
	ld B, D

	ld A, #0x80
	call delay
	call NZ, scroll_up

	ld A, #0x20
	call delay
	call NZ, scroll_down

	ld A, #0x10
	call delay

	pop BC
	pop HL
	ret

;
; ҂
;
; 
; A:L[Xg[u
; B:҂
; HL:pos
;
; o
; AF:j
;
delay:
	out (#0x11), A

	push BC
delay_loop:
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	djnz delay_loop
	pop BC

	in A, (#0x10)
	or A
	ret

scroll_up:
	inc (HL)
	dec (HL)
	ret Z

	dec (HL)
	ret

scroll_down:
	ld A, (#height)
	;dec A
	cp (HL)
	ret Z

	inc (HL)
	ret

;
; k摜1v[1s\
;
; 
; A:s + 0xb0
; C:0x40
; D:҂
; HL:k摜̐擪
;
; o
; D:҂
; HL:̈k摜̐擪
; AF,BC,E:j
;
put_line:
	push AF
	push HL

	; YWݒ肷
	out (C), A

	; XWݒ肷
	ld A, #0x10
	out (C), A
	xor A
	out (C), A

	; f[^̐擪𓾂
	ld A, (HL)
	inc HL
	ld H, (HL)
	ld L, A

	; \ςݒ
	ld E, #-144

	; ҂Ԃ𓾂
	ld A, D
	add (HL)
	ld D, A
	inc HL

	; o̓|[gݒ肷
	inc C

put_line_loop:
	; f[^𓾂
	ld A, (HL)
	inc HL
	ld B, A
	sub #2
	cp #143
	jr C, put_line2

put_line1:
	; sAf[^WJ
	sub #142
	ld B, A
	add E
	ld E, A
	otir
	jr put_line_skip

put_line2:
	; Af[^WJ
	ld A, B
	add E
	ld E, A
	ld A, (HL)
	inc HL
put_line2_loop:
	out (C), A
	djnz put_line2_loop

put_line_skip:
	; 1sSēWJ?
	inc E
	dec E
	jr NZ, put_line_loop

	dec C

	pop HL
	pop AF

	inc A
	inc HL
	inc HL
	ret

; 
height:
	.ds 1

; (8̔{)
height2:
	.ds 1

; \ʒu
pos:
	.ds 1

.area _DATA

; Copyright 2011, 2012 maruhiro
; All rights reserved. 
;
; Redistribution and use in source and binary forms, 
; with or without modification, are permitted provided that 
; the following conditions are met: 
;
;  1. Redistributions of source code must retain the above copyright notice, 
;     this list of conditions and the following disclaimer. 
;
;  2. Redistributions in binary form must reproduce the above copyright notice, 
;     this list of conditions and the following disclaimer in the documentation 
;     and/or other materials provided with the distribution. 
;
; THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
; INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
; FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
; THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
; SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
; OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
; ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

; eof
